#include "HMC5883.h"

#define HMC5883_I2c				I2C2
#define DTR_Pin						GPIOE, GPIO_Pin_15

void HMC5883_Init (void)
{
	I2C2_Init(HMC5883_I2c);
	//I2C_Write_Byte(HMC5883_I2c, HMC5883_I2c_ADDRESS, Config_A_reg, 0x70);	
	//I2C_Write_Byte(HMC5883_I2c, HMC5883_I2c_ADDRESS, Config_B_reg, 0x20);	
	I2C_Write_Byte(HMC5883_I2c, HMC5883_I2c_ADDRESS, Mode_reg, 0);	
}

unsigned char HMC5883_Get_Data (unsigned int * x, unsigned int * y, unsigned int * z)
{
	unsigned char raw_dat[6];
	if (!HMC5883_Check_Ready_Flag())
	{
		I2C_XYZ(HMC5883_I2c, HMC5883_I2c_ADDRESS, &raw_dat);
		*x=raw_dat[1]|(raw_dat[0]<<8);
		*y=raw_dat[5]|(raw_dat[4]<<8);
		*z=raw_dat[3]|(raw_dat[2]<<8);
		return !0;
	}
	else
		return 0;
}

unsigned char HMC5883_Check_Ready_Flag (void)
{
	unsigned char raw_dat[HMC5883_Page_Size];	
	I2C_Read_Page(HMC5883_I2c, HMC5883_I2c_ADDRESS, &raw_dat);
	return (1&raw_dat[7]);
}

unsigned char HMC5883_ID_Check (void)
{
	unsigned char raw_dat[3];
	unsigned char err_cnt=0;
	I2C_Get_ID(HMC5883_I2c, HMC5883_I2c_ADDRESS, &raw_dat);
	if (raw_dat[0]!=ID_A) err_cnt++;	
	if (raw_dat[1]!=ID_B) err_cnt++;	
	if (raw_dat[2]!=ID_C) err_cnt++;
	return err_cnt;
}
